import { ElementRef, OnInit } from '@angular/core';
import { DomSanitizer } from '@angular/platform-browser';
import { TransitionService } from '@uirouter/angular';
import { I18NextPipe } from 'angular-i18next';
import { NwfPageAlertService } from './page-alert.service';
export declare class PageAlertComponent implements OnInit {
    private element;
    private sanitizer;
    private transitionService;
    private i18next;
    message: any;
    severity: string;
    isShowing: boolean;
    extraInformation: string;
    showMoreInfo: boolean;
    showMoreButtonText: string;
    private subscription;
    constructor(element: ElementRef, pageAlertService: NwfPageAlertService, sanitizer: DomSanitizer, transitionService: TransitionService, i18next: I18NextPipe);
    ngOnInit(): void;
    ngOnDestroy(): void;
    show({ message, severity, fade }: {
        message: any;
        severity: any;
        fade: any;
    }): void;
    close(): void;
    toggleMoreInfoVisibility(): void;
    resetFlags(): void;
    readonly stateClass: string;
}
