/**
 * State-based routing for Angular
 * @version v2.0.2
 * @link https://ui-router.github.io/angular
 * @license MIT License, http://www.opensource.org/licenses/MIT
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports,require("@uirouter/core"),require("@angular/core"),require("rxjs"),require("rxjs/operators"),require("@angular/common"),require("@angular/router"),require("@uirouter/rx")):"function"==typeof define&&define.amd?define(["exports","@uirouter/core","@angular/core","rxjs","rxjs/operators","@angular/common","@angular/router","@uirouter/rx"],t):t(e["@uirouter/angular"]={},e["@uirouter/core"],e.ng.core,e.rxjs,e.operators,e.ng.common,e.ng.router,e["@uirouter/rx"])}(this,function(t,g,s,o,n,u,r,c){"use strict";function p(n){var i={},e=n.views||{$default:g.pick(n,["component","bindings"])};return g.forEach(e,function(e,t){if(t=t||"$default",g.isFunction(e)&&(e={component:e}),0!==Object.keys(e).length){e.$type="ng2",e.$context=n,e.$name=t;var r=g.ViewService.normalizeUIViewTarget(e.$context,e.$name);e.$uiViewName=r.uiViewName,e.$uiViewContextAnchor=r.uiViewContextAnchor,i[t]=e}}),i}var i=0,f=function(){function e(e,t){this.path=e,this.viewDecl=t,this.$id=i++,this.loaded=!0}return e.prototype.load=function(){return g.services.$q.when(this)},e}(),l=function(){function i(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];if(e.length<2)throw new Error("pass at least two injectors");this.injectors=e}return i.prototype.get=function(e,t){for(var r=0;r<this.injectors.length;r++){var n=this.injectors[r].get(e,i.NOT_FOUND);if(n!==i.NOT_FOUND)return n}if(2<=arguments.length)return t;this.injectors[0].get(e)},i.NOT_FOUND={},i}(),h=0,d=function(e){return e.inputs.map(function(e){return{prop:e.propName,token:e.templateName}})},e=d,a=function(){function a(e,t,r){this.router=e,this.viewContainerRef=r,this._uiViewData={},this._parent=t}return Object.defineProperty(a.prototype,"_name",{set:function(e){this.name=e},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"state",{get:function(){return g.parse("_uiViewData.config.viewDecl.$context.self")(this)},enumerable:!0,configurable:!0}),a.prototype.ngOnInit=function(){var t=this,e=this.router,r=this._parent.fqn,n=this.name||"$default";this._uiViewData={$type:"ng2",id:h++,name:n,fqn:r?r+"."+n:n,creationContext:this._parent.context,configUpdated:this._viewConfigUpdated.bind(this),config:void 0},this._deregisterUiCanExitHook=e.transitionService.onBefore({},function(e){return t._invokeUiCanExitHook(e)}),this._deregisterUiOnParamsChangedHook=e.transitionService.onSuccess({},function(e){return t._invokeUiOnParamsChangedHook(e)}),this._deregisterUIView=e.viewService.registerUIView(this._uiViewData)},a.prototype._invokeUiCanExitHook=function(e){var t=this._componentRef&&this._componentRef.instance,r=t&&t.uiCanExit;if(g.isFunction(r)){var n=this.state;-1!==e.exiting().indexOf(n)&&e.onStart({},function(){return r.call(t,e)})}},a.prototype._invokeUiOnParamsChangedHook=function(e){var t=this._componentRef&&this._componentRef.instance,r=t&&t.uiOnParamsChanged;if(g.isFunction(r)){var n=this.state;if(e===new g.ResolveContext(this._uiViewData.config.path).getResolvable("$transition$").data||-1!==e.exiting().indexOf(n))return;var i=e.params("to"),o=e.params("from"),a=function(e){return e.paramSchema},s=e.treeChanges("to").map(a).reduce(g.unnestR,[]),u=e.treeChanges("from").map(a).reduce(g.unnestR,[]),c=s.filter(function(e){var t=u.indexOf(e);return-1===t||!u[t].type.equals(i[e.id],o[e.id])});if(c.length){var p=c.map(function(e){return e.id}),f=g.filter(i,function(e,t){return-1!==p.indexOf(t)});t.uiOnParamsChanged(f,e)}}},a.prototype._disposeLast=function(){this._componentRef&&this._componentRef.destroy(),this._componentRef=null},a.prototype.ngOnDestroy=function(){this._deregisterUIView&&this._deregisterUIView(),this._deregisterUiCanExitHook&&this._deregisterUiCanExitHook(),this._deregisterUiOnParamsChangedHook&&this._deregisterUiOnParamsChangedHook(),this._deregisterUIView=this._deregisterUiCanExitHook=this._deregisterUiOnParamsChangedHook=null,this._disposeLast()},a.prototype._viewConfigUpdated=function(e){if(!e)return this._disposeLast();e instanceof f&&this._uiViewData.config!==e&&(this._disposeLast(),g.trace.traceUIViewConfigUpdated(this._uiViewData,e&&e.viewDecl.$context),this._applyUpdatedConfig(e),this._componentRef.changeDetectorRef.markForCheck())},a.prototype._applyUpdatedConfig=function(e){this._uiViewData.config=e;var t=new g.ResolveContext(e.path),r=this._getComponentInjector(t),n=e.viewDecl.component,i=r.get(s.ComponentFactoryResolver).resolveComponentFactory(n);this._componentRef=this._componentTarget.createComponent(i,void 0,r),this._applyInputBindings(i,this._componentRef.instance,t,n)},a.prototype._getComponentInjector=function(t){var e=t.getTokens().map(function(e){return t.getResolvable(e)}).filter(function(e){return e.resolved}).map(function(e){return{provide:e.token,useValue:t.injector().get(e.token)}}),r={context:this._uiViewData.config.viewDecl.$context,fqn:this._uiViewData.fqn};e.push({provide:a.PARENT_INJECT,useValue:r});var n=this.viewContainerRef.injector,i=t.getResolvable(g.NATIVE_INJECTOR_TOKEN).data,o=new l(i,n);return s.ReflectiveInjector.resolveAndCreate(e,o)},a.prototype._applyInputBindings=function(i,t,r,e){var o=this._uiViewData.config.viewDecl.bindings||{},n=Object.keys(o),a=n.reduce(function(e,t){return e.concat([{prop:(r=t,n=i.inputs.find(function(e){return e.templateName===r}),n&&n.propName||r),token:o[t]}]);var r,n},[]),s=d(i).filter(function(e){return!g.inArray(n,e.prop)}),u=r.injector();a.concat(s).map(function(e){return{prop:e.prop,resolvable:r.getResolvable(e.token)}}).filter(function(e){return e.resolvable&&e.resolvable.resolved}).forEach(function(e){t[e.prop]=u.get(e.resolvable.token)})},a.PARENT_INJECT="UIView.PARENT_INJECT",a.decorators=[{type:s.Component,args:[{selector:"ui-view, [ui-view]",exportAs:"uiView",template:'\n    <ng-template #componentTarget></ng-template>\n    <ng-content *ngIf="!_componentRef"></ng-content>\n  '}]}],a.ctorParameters=function(){return[{type:g.UIRouter},{type:void 0,decorators:[{type:s.Inject,args:[a.PARENT_INJECT]}]},{type:s.ViewContainerRef}]},a.propDecorators={_componentTarget:[{type:s.ViewChild,args:["componentTarget",{read:s.ViewContainerRef}]}],name:[{type:s.Input,args:["name"]}],_name:[{type:s.Input,args:["ui-view"]}]},a}();function v(t,e,r){return void 0===r&&(r={}),g.isFunction(r.config)&&r.config(t,e,r),(r.states||[]).map(function(e){return t.stateRegistry.register(e)})}function _(e,t,r){g.isDefined(r.deferIntercept)&&e.urlService.deferIntercept(r.deferIntercept),g.isDefined(r.otherwise)&&e.urlService.rules.otherwise(r.otherwise),g.isDefined(r.initial)&&e.urlService.rules.initial(r.initial)}var y=function(){function e(e,t){this._el=e,this._renderer=t}return e.prototype.openInNewTab=function(){return"_blank"===this._el.nativeElement.target},e.prototype.update=function(e){e&&""!==e?this._renderer.setProperty(this._el.nativeElement,"href",e):this._renderer.removeAttribute(this._el.nativeElement,"href")},e.decorators=[{type:s.Directive,args:[{selector:"a[uiSref]"}]}],e.ctorParameters=function(){return[{type:s.ElementRef},{type:s.Renderer2}]},e}(),m=function(){function e(e,t,r){var n=this;this.targetState$=new o.ReplaySubject(1),this._emit=!1,this._router=e,this._anchorUISref=t,this._parent=r,this._statesSub=e.globals.states$.subscribe(function(){return n.update()})}return Object.defineProperty(e.prototype,"uiSref",{set:function(e){this.state=e,this.update()},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"uiParams",{set:function(e){this.params=e,this.update()},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"uiOptions",{set:function(e){this.options=e,this.update()},enumerable:!0,configurable:!0}),e.prototype.ngOnInit=function(){this._emit=!0,this.update()},e.prototype.ngOnChanges=function(e){this.update()},e.prototype.ngOnDestroy=function(){this._emit=!1,this._statesSub.unsubscribe(),this.targetState$.unsubscribe()},e.prototype.update=function(){var e=this._router.stateService;if(this._emit){var t=e.target(this.state,this.params,this.getOptions());this.targetState$.next(t)}if(this._anchorUISref){var r=e.href(this.state,this.params,this.getOptions());this._anchorUISref.update(r)}},e.prototype.getOptions=function(){var e={relative:this._parent&&this._parent.context&&this._parent.context.name,inherit:!0,source:"sref"};return g.extend(e,this.options||{})},e.prototype.go=function(e,t,r){if(!(this._anchorUISref&&(this._anchorUISref.openInNewTab()||e||!g.isNumber(e)||t||r)||!this.state))return this._router.stateService.go(this.state,this.params,this.getOptions()),!1},e.decorators=[{type:s.Directive,args:[{selector:"[uiSref]",exportAs:"uiSref"}]}],e.ctorParameters=function(){return[{type:g.UIRouter},{type:y,decorators:[{type:s.Optional}]},{type:void 0,decorators:[{type:s.Inject,args:[a.PARENT_INJECT]}]}]},e.propDecorators={state:[{type:s.Input,args:["uiSref"]}],params:[{type:s.Input,args:["uiParams"]}],options:[{type:s.Input,args:["uiOptions"]}],go:[{type:s.HostListener,args:["click",["$event.button","$event.ctrlKey","$event.metaKey"]]}]},e}(),R={active:!1,exact:!1,entering:!1,exiting:!1,targetStates:[]};function S(e,r){return r.map(function(t){return e.concat(g.PathUtils.subPath(r,function(e){return e.state===t.state}))})}function I(e,t){var r=function(e){if(!e.exists())return function(){return!1};var n=e.$state(),i=e.params(),o=g.PathUtils.buildPath(e).map(function(e){return e.paramSchema}).reduce(g.unnestR,[]).filter(function(e){return i.hasOwnProperty(e.id)});return function(e){var t=g.tail(e);if(!t||t.state!==n)return!1;var r=g.PathUtils.paramValues(e);return g.Param.equals(o,r,i)}}(t),n=e.trans.treeChanges(),i="start"===e.evt,o="success"===e.evt?n.to:n.from;return{active:S([],o).map(r).reduce(g.anyTrueR,!1),exact:r(o),entering:!!i&&S(n.retained,n.entering).map(r).reduce(g.anyTrueR,!1),exiting:!!i&&S(n.retained,n.exiting).map(r).reduce(g.anyTrueR,!1),targetStates:[t]}}function b(e,t){return{active:e.active||t.active,exact:e.exact||t.exact,entering:e.entering||t.entering,exiting:e.exiting||t.exiting,targetStates:e.targetStates.concat(t.targetStates)}}var E=function(){function e(e){this.uiSrefStatus=new s.EventEmitter(!1),this._globals=e,this.status=Object.assign({},R)}return e.prototype.ngAfterContentInit=function(){var t=this,e=this._globals.start$.pipe(n.switchMap(function(t){var e=function(e){return{evt:e,trans:t}},r=o.of(e("start")),n=t.promise.then(function(){return e("success")},function(){return e("error")}),i=o.from(n);return o.concat(r,i)}));this._srefs$=new o.BehaviorSubject(this._srefs.toArray()),this._srefChangesSub=this._srefs.changes.subscribe(function(e){return t._srefs$.next(e)});var r=this._srefs$.pipe(n.switchMap(function(e){return o.combineLatest(e.map(function(e){return e.targetState$}))}));this._subscription=e.pipe(n.switchMap(function(t){return r.pipe(n.map(function(e){return e.map(function(e){return I(t,e)}).reduce(b)}))})).subscribe(this._setStatus.bind(this))},e.prototype.ngOnDestroy=function(){this._subscription&&this._subscription.unsubscribe(),this._srefChangesSub&&this._srefChangesSub.unsubscribe(),this._srefs$&&this._srefs$.unsubscribe(),this._subscription=this._srefChangesSub=this._srefs$=void 0},e.prototype._setStatus=function(e){this.status=e,this.uiSrefStatus.emit(e)},e.decorators=[{type:s.Directive,args:[{selector:"[uiSrefStatus],[uiSrefActive],[uiSrefActiveEq]",exportAs:"uiSrefStatus"}]}],e.ctorParameters=function(){return[{type:g.UIRouterGlobals}]},e.propDecorators={uiSrefStatus:[{type:s.Output,args:["uiSrefStatus"]}],_srefs:[{type:s.ContentChildren,args:[m,{descendants:!0}]}]},e}(),U=function(){function e(e,r,n){var i=this;this._classes=[],this._classesEq=[],this._subscription=e.uiSrefStatus.subscribe(function(t){i._classes.forEach(function(e){t.active?r.addClass(n.nativeElement,e):r.removeClass(n.nativeElement,e)}),i._classesEq.forEach(function(e){t.exact?r.addClass(n.nativeElement,e):r.removeClass(n.nativeElement,e)})})}return Object.defineProperty(e.prototype,"active",{set:function(e){this._classes=e.split(/\s+/)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"activeEq",{set:function(e){this._classesEq=e.split(/\s+/)},enumerable:!0,configurable:!0}),e.prototype.ngOnDestroy=function(){this._subscription.unsubscribe()},e.decorators=[{type:s.Directive,args:[{selector:"[uiSrefActive],[uiSrefActiveEq]"}]}],e.ctorParameters=function(){return[{type:E},{type:s.Renderer2},{type:s.ElementRef,decorators:[{type:s.Host}]}]},e.propDecorators={active:[{type:s.Input,args:["uiSrefActive"]}],activeEq:[{type:s.Input,args:["uiSrefActiveEq"]}]},e}(),w=[m,y,a,U,E],C=w,O=new s.InjectionToken("UIRouter Root Module"),T=new s.InjectionToken("UIRouter Module"),x=new s.InjectionToken("UIRouter States");function P(e,t){var r=t[0];return r&&r.deferInitialRender?function(){return new Promise(function(t){e.onStart({},function(e){e.promise.then(t,t)},{invokeLimit:1})})}:function(){return Promise.resolve()}}function N(e){return[{provide:O,useValue:e,multi:!0},{provide:T,useValue:e,multi:!0},{provide:r.ROUTES,useValue:e.states||[],multi:!0},{provide:s.ANALYZE_FOR_ENTRY_COMPONENTS,useValue:e.states||[],multi:!0},{provide:s.APP_INITIALIZER,useFactory:P,deps:[g.TransitionService,O],multi:!0}]}function V(e){return[{provide:T,useValue:e,multi:!0},{provide:r.ROUTES,useValue:e.states||[],multi:!0},{provide:s.ANALYZE_FOR_ENTRY_COMPONENTS,useValue:e.states||[],multi:!0}]}function D(e){return{provide:u.LocationStrategy,useClass:e?u.HashLocationStrategy:u.PathLocationStrategy}}var A=function(){function t(){}return t.forRoot=function(e){return void 0===e&&(e={}),{ngModule:t,providers:[Y,ne,D(e.useHash)].concat(N(e))}},t.forChild=function(e){return void 0===e&&(e={}),{ngModule:t,providers:V(e)}},t.decorators=[{type:s.NgModule,args:[{imports:[u.CommonModule],declarations:[w],exports:[w],entryComponents:[a]}]}],t}();function j(e){return function(t,r){var n=t.injector().get(g.NATIVE_INJECTOR_TOKEN);return $(e,n).then(function(e){return e.create(n)}).then(function(e){return k(t,e,n,r)})}}function $(e,t){if(g.isString(e))return t.get(s.NgModuleFactoryLoader).load(e);var r=t.get(s.Compiler),n=r instanceof s.Compiler,i=Promise.resolve(e()).then(function(e){return e&&e.__esModule&&e.default?e.default:e});return n?i:i.then(function(e){return r.compileModuleAsync(e)})}function k(e,t,r,n){var i=t.injector,o=i.get(g.UIRouter),a=o.stateRegistry,s=n.name,u=a.get(s),c=/^(.*)\.\*\*$/.exec(s),p=c&&c[1],f=F(r,i,O).reduce(g.uniqR,[]),l=F(r,i,T).reduce(g.uniqR,[]);if(f.length)throw console.log(f),new Error("Lazy loaded modules should not contain a UIRouterModule.forRoot() module");var h=l.map(function(e){return v(o,i,e)}).reduce(g.unnestR,[]).reduce(g.uniqR,[]);if(c){var d=a.get(p);if(!d||d===u)throw new Error("The Future State named '"+s+"' lazy loaded an NgModule. The lazy loaded NgModule must have a state named '"+p+"' which replaces the (placeholder) '"+s+"' Future State. Add a '"+p+"' state to the lazy loaded NgModule using UIRouterModule.forChild({ states: CHILD_STATES }).")}return h.filter(function(e){return!g.inArray(h,e.parent)}).forEach(function(e){return e.resolvables.push(g.Resolvable.fromData(g.NATIVE_INJECTOR_TOKEN,i))}),{}}function F(e,t,r){var n=t.get(r,[]),i=e.get(r,[]);return n.filter(function(e){return-1===i.indexOf(e)})}function M(e,t){var r=e.loadChildren;return r?j(r):e.lazyLoad}var L=function(e,t){return(L=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r])})(e,t)};function q(e,t){function r(){this.constructor=e}L(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}var H=function(i){function e(e,t,r){var n=i.call(this,e,r)||this;return n._locationStrategy=t,n._locationStrategy.onPopState(function(e){"hashchange"!==e.type&&n._listener(e)}),n}return q(e,i),e.prototype._get=function(){return this._locationStrategy.path(!0).replace(this._locationStrategy.getBaseHref().replace(/\/$/,""),"")},e.prototype._set=function(e,t,r,n){var i=g.parseUrl(r),o=i.path,a=i.search,s=i.hash,u=o+(s?"#"+s:"");n?this._locationStrategy.replaceState(e,t,u,a):this._locationStrategy.pushState(e,t,u,a)},e.prototype.dispose=function(e){i.prototype.dispose.call(this,e)},e}(g.BaseLocationServices),B=function(n){function e(e,t){var r=n.call(this,e,g.is(u.PathLocationStrategy)(t))||this;return r._locationStrategy=t,r}return q(e,n),e.prototype.baseHref=function(e){return this._locationStrategy.getBaseHref()},e}(g.BrowserLocationConfig);function J(e,t,r,n){if(1!==t.length)throw new Error("Exactly one UIRouterModule.forRoot() should be in the bootstrapped app module's imports: []");var i=new g.UIRouter;i.plugin(c.UIRouterRx),i.plugin(g.servicesPlugin),g.services.$injector.get=n.get.bind(n),i.locationService=new H(i,e,u.isPlatformBrowser(n.get(s.PLATFORM_ID))),i.locationConfig=new B(i,e);i.viewService._pluginapi._viewConfigFactory("ng2",function(e,t){return new f(e,t)});var o=i.stateRegistry;o.decorator("views",p),o.decorator("lazyLoad",M);var a=g.Resolvable.fromData(g.NATIVE_INJECTOR_TOKEN,n);return o.root().resolvables.push(a),i.urlMatcherFactory.$get(),t.forEach(function(e){return _(i,0,e)}),r.forEach(function(e){return v(i,n,e)}),i}function z(e){return function(){e.urlRouter.interceptDeferred||(e.urlService.listen(),e.urlService.sync())}}function K(e){return{fqn:null,context:e.root()}}var Y=[{provide:g.UIRouter,useFactory:J,deps:[u.LocationStrategy,O,T,s.Injector]},{provide:a.PARENT_INJECT,useFactory:K,deps:[g.StateRegistry]},{provide:s.APP_INITIALIZER,useFactory:z,deps:[g.UIRouter],multi:!0}];function Z(e){return e.stateService}function G(e){return e.transitionService}function Q(e){return e.urlMatcherFactory}function W(e){return e.urlRouter}function X(e){return e.urlService}function ee(e){return e.viewService}function te(e){return e.stateRegistry}function re(e){return e.globals}var ne=[{provide:g.StateService,useFactory:Z,deps:[g.UIRouter]},{provide:g.TransitionService,useFactory:G,deps:[g.UIRouter]},{provide:g.UrlMatcherFactory,useFactory:Q,deps:[g.UIRouter]},{provide:g.UrlRouter,useFactory:W,deps:[g.UIRouter]},{provide:g.UrlService,useFactory:X,deps:[g.UIRouter]},{provide:g.ViewService,useFactory:ee,deps:[g.UIRouter]},{provide:g.StateRegistry,useFactory:te,deps:[g.UIRouter]},{provide:g.UIRouterGlobals,useFactory:re,deps:[g.UIRouter]}],ie=Y.concat(ne);Object.keys(g).forEach(function(e){t[e]=g[e]}),t.uiRouterFactory=J,t.appInitializer=z,t.parentUIViewInjectFactory=K,t._UIROUTER_INSTANCE_PROVIDERS=Y,t.fnStateService=Z,t.fnTransitionService=G,t.fnUrlMatcherFactory=Q,t.fnUrlRouter=W,t.fnUrlService=X,t.fnViewService=ee,t.fnStateRegistry=te,t.fnGlobals=re,t._UIROUTER_SERVICE_PROVIDERS=ne,t.UIROUTER_PROVIDERS=ie,t.UIROUTER_ROOT_MODULE=O,t.UIROUTER_MODULE_TOKEN=T,t.UIROUTER_STATES=x,t.onTransitionReady=P,t.makeRootProviders=N,t.makeChildProviders=V,t.locationStrategy=D,t.UIRouterModule=A,t.applyModuleConfig=v,t.applyRootModuleConfig=_,t._UIROUTER_DIRECTIVES=w,t.UIROUTER_DIRECTIVES=C,t.UIView=a,t.ɵ0=e,t.AnchorUISref=y,t.UISref=m,t.UISrefStatus=E,t.UISrefActive=U,t.ng2ViewsBuilder=p,t.Ng2ViewConfig=f,t.ng2LazyLoadBuilder=M,t.loadNgModule=j,t.loadModuleFactory=$,t.applyNgModule=k,t.multiProviderParentChildDelta=F,Object.defineProperty(t,"__esModule",{value:!0})});
//# sourceMappingURL=ui-router-ng2.min.js.map
